﻿:Namespace rebuild

    ⎕IO←1 ⋄ ⎕ML←1

    ∇ r←List
      r←⎕NS ⍬
   ⍝ Name, group, short description and parsing rules
      r.(Name Group Parse)←'Rebuild' 'SALT' '1 -scripted[=]'
      r.Desc←'Reconstruct a ws Snapped with -nstofolder'
    ∇

    ∇ r←Run(Cmd Input);scripted;file
      scripted←Input.scripted ⋄ file←1⊃Input.Arguments
      r←(scripted ##.THIS)rebuildwsfrom file
    ∇

   ⍝ This fn can be called independently of user command
    ∇ r←la rebuildwsfrom filename;nsname;target;sysvars;sv;withsource;s;nc;nosrc
      (withsource target)←2↑la,⊃⌽⎕RSI ⋄ sysvars←target.(⎕IO ⎕ML)
      nsname←{⍵↑⍨-⊥⍨~⍵∊'/\'}filename
      :If ~0 1∊⍨⊂s←withsource ⋄ nsname←s ⋄ :EndIf
      :If ~nosrc←s≡0
          nc←target.⎕NC nsname
          (nsname,(1+nc<0)⊃' already in use' ' is an invalid name')⎕SIGNAL(0≠nc)/11
      :EndIf
      r←nosrc rebuild filename
      :If nosrc
          (s←⍕target)⎕NS r
          r←'names dispersed in ',s
      :Else
          sv←'(⎕io ⎕ml)←',⍕sysvars
          target.⎕FIX(':namespace ',nsname)sv,r,⊂':endnamespace'
          r←nsname,' rebuilt'
      :EndIf
    ∇

    ∇ r←nsrc rebuild filename;src;files;file;U;dir;dels;dfn
     ⍝ Start at filename and gather objects
      U←⎕SE.SALTUtils
      r←⍬ ⋄ :If nsrc ⋄ 'r'⎕NS'' ⋄ :EndIf
      files←1 0 0 1/'a'U.Dir filename,U.FS,'*'
      :For dir file :InEach files
          :If dir
              :If nsrc
                  ('r.',file)⎕NS nsrc rebuild filename,U.FS,file
              :Else
                  r,←''(':namespace ',file)'',(nsrc rebuild filename,U.FS,file),'' ':endnamespace' ''
              :EndIf
          :Else ⍝ it's either a fn or a var
              :If '⌷'=1↑1⊃src←U.splitOnNL filename,U.FS,file
                  :If nsrc ⋄ r⍎1↓1⊃src
                  :Else ⋄ r,←1↓¨src
                  :EndIf
              :Else ⍝ a function
                  :If nsrc ⋄ r.⎕FX src
                  :Else
                      dfn←'}'≠⊃⌽⊃⌽src
                      dels←1⌽(1+⍴src)↑dfn/'∇∇'
                      r,←dels,¨src,⊂''
                  :EndIf
              :EndIf
          :EndIf
      :EndFor
    ∇

    ∇ r←level Help Cmd;⎕ML
      ⎕ML←1
      r←⍬
      r,←⊂'After a ws was Snapped with switch -nstofolder it may be desirable to bring it back.'
      r,←⊂'This cmd will allow you to do that.'
      r,←⊂'Simply give it the location of the top folder as argument.'
      r,←⊂'With -scripted, a scripted namespace will be rebuilt using the same name as the file.'
      r,←⊂'With -scripted=NAME, a scripted namespace will be rebuilt using NAME.'
      r,←⊂'The name must not exist.'
      →level↓end
      r,←⊂'Ex:'
      r,←⊂'   ]snap \my\ws -nstofolder'
      r,←⊂'   )clear'
      r,←⊂'   ]rebuild  \my\ws'
      r,←⊂'   ]rebuild  \my\ws -scripted=copyofws'
     end:r←↑r
    ∇

:EndNamespace